%phasebatch1; this routine calls programme "dfb15" which in turn generates
% a 3-dimentional plot of spectra as facet phase is changed.  The programmes
% used are almost identical to those such as "dfbuni" and others, but
% modified slightly to include reflective facets.  The main programee is run
% via this "batch" programme so that sets of runs may be done, changing one
% or more parameters for each run. For instance, as stored, this programme 
% will generate just one plot using the parameters below including a coupling
% coefficient (kappa) of 30/cm. However, at the end are two lines commented 
% out which change kappa to a complex value of 21 + 21*i and generates another
% plot by calling dfb15 again.  This is a useful facility, because the plots 
% take 10 minutes or so to run with a 500 MHz PC, and a whole series of plots
% can then be generated by running the computer automatically overnight.
% ******************
% trun is set here to 25 ns, which gives a good, high resolution plot.  
% However, "trun" can be reduced to about 10 ns to get "draft quality" plots
% more quickly, or indeed it can be increased to 50 or more if very high 
% resolution is required.

trun = 25; % time-per-spectrum is fixed, so shorter run time gives less
             % spectra per phase scan, and vice versa.
             
Drv = 5;     % drive normalised to transparency. Useful range is about 2 up
             % to about 20.
             
bshot = 1;   % 1 or 0 correspond to the presence of shot noise on the drive
             % current or not, as required. Including noise is usually
             % appropriate.
             
philscan = 4*pi;  % sets the range of left facet phases covered. 2*pi is a
             % single cycle, but using 4*pi makes the cyclic results clearer.
             
kappa = 30;  
             % coupling coefficient per cm. Complex values (including "gain
             % coupling") are accepted in the form A + j*B. Note that A - j*B
             % will usually give a very different result.
             
L = 350;     % laser length in microns.

Rleft = 0.93; % left facet power reflectivity.

phil = 0;    % STARTING phase for left facet.

Rright = 0;  % right facet reflectivity.

phir = 0;    % right facet phase. Note that this value is static, but it may
             % be scanned instead of the left facet phase by substituting "phir"
             % for "phil" in the main run loop of dfb15.
dfb15;

%kappa = j*20;  % these two lines are commented out, but illustrate how 
%dfb15;         % several plots can be run automatically from this master
% batch programme.

rotate3d;
disp('click on figure with mouse to rotate 3d display');
